config/routes.rb
Rails.application.routes.draw do
  root 'ideas#index'
  resources :ideas

end

app/models/idea.rb
class Idea < ActiveRecord::Base
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/ideas_controller.rb
class IdeasController < ApplicationController
  before_action :set_idea, only: [:show, :edit, :update, :destroy]

  # GET /ideas
  # GET /ideas.json
  def index
    @ideas = Idea.all
  end

  # GET /ideas/1
  # GET /ideas/1.json
  def show
  end

  # GET /ideas/new
  def new
    @idea = Idea.new
  end

  # GET /ideas/1/edit
  def edit
  end

  # POST /ideas
  # POST /ideas.json
  def create
    @idea = Idea.new(idea_params)

    respond_to do |format|
      if @idea.save
        format.html { redirect_to @idea, notice: 'Idea was successfully created.' }
        format.json { render :show, status: :created, location: @idea }
      else
        format.html { render :new }
        format.json { render json: @idea.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /ideas/1
  # PATCH/PUT /ideas/1.json
  def update
    respond_to do |format|
      if @idea.update(idea_params)
        format.html { redirect_to @idea, notice: 'Idea was successfully updated.' }
        format.json { render :show, status: :ok, location: @idea }
      else
        format.html { render :edit }
        format.json { render json: @idea.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /ideas/1
  # DELETE /ideas/1.json
  def destroy
    @idea.destroy
    respond_to do |format|
      format.html { redirect_to ideas_url, notice: 'Idea was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_idea
      @idea = Idea.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def idea_params
      params.require(:idea).permit(:label, :short_label, :description)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/ideas_helper.rb
module IdeasHelper
end

app/views/ideas/_form.html.erb
<%= form_for(@idea) do |f| %>
  <% if @idea.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@idea.errors.count, "error") %> prohibited this idea from being saved:</h2>

      <ul>
      <% @idea.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :label %><br>
    <%= f.text_field :label %>
  </div>
  <div class="field">
    <%= f.label :short_label %><br>
    <%= f.text_field :short_label %>
  </div>
  <div class="field">
    <%= f.label :description %><br>
    <%= f.text_area :description %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/ideas/edit.html.erb
<h1>Editing Idea</h1>

<%= render 'form' %>

<%= link_to 'Show', @idea %> |
<%= link_to 'Back', ideas_path %>

app/views/ideas/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Ideas</h1>

<table>
  <thead>
    <tr>
      <th>Label</th>
      <th>Short label</th>
      <th>Description</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @ideas.each do |idea| %>
      <tr>
        <td><%= idea.label %></td>
        <td><%= idea.short_label %></td>
        <td><%= idea.description %></td>
        <td><%= link_to 'Show', idea %></td>
        <td><%= link_to 'Edit', edit_idea_path(idea) %></td>
        <td><%= link_to 'Destroy', idea, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Idea', new_idea_path %>

app/views/ideas/new.html.erb
<h1>New Idea</h1>

<%= render 'form' %>

<%= link_to 'Back', ideas_path %>

app/views/ideas/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Label:</strong>
  <%= @idea.label %>
</p>

<p>
  <strong>Short label:</strong>
  <%= @idea.short_label %>
</p>

<p>
  <strong>Description:</strong>
  <%= @idea.description %>
</p>

<%= link_to 'Edit', edit_idea_path(@idea) %> |
<%= link_to 'Back', ideas_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>W5Testing</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>

<%= yield %>

</body>
</html>